TITLE Freehafer's read FAT 12, 16, or 32 sector program uses 7305h.
;........................................................................
msg	MACRO	msgout
	mov AH, 09h				; function 09h
	lea DX, msgout			; DX holds message
	int 21h 				; display string interupt
ENDM
;........................................................................
.MODEL small		      	; directive placing all memory in one segment
;........................................................................
;
;...................................; stack segment......................
StackSeg segment stack	      	; stack segment begins
StackSeg ends		      	; stack segment ends
;........................................................................
;
;...................................; data segment.......................
DataSeg segment

	drive 		DB	?
	buffy			DB 	512 dup (?)
	dio 			EQU 	THIS BYTE
	diStartSector	DD	?			; sector # to start = 0 for boot
	diSectors		DW	1			; number of sectors to read = 1
	diBuffer		DD	DWORD PTR buffy	; address of buffer
	NUMVALUE		DB	?
	PATH 			DB 	"absr.doc",0
	HANDLE 		DW 	0
	CRLF			DB 	10,13,'$'
	MessageIn		DB	0Ah,0Dh,0Ah,0Dh,"     This program reads FAT 12 16 or 32 boot sectors.",0Ah,0Dh,0Ah,0Dh,"     To read a drive boot sector, enter a drive letter: ",'$' 
	Message0		DB 	0Ah,0Dh,0Ah,0Dh,"     This program read the boot sector of drive ",'$'
	Message1		DB	"     put the information into the file absr.doc,",0Ah,0Dh,"     and displays the drive's media ID to be: ",'$'
	Message2		DB	"!",0Ah,0Dh,0Ah,0Dh,"     (C)2002 Inniea Publishing Company!",0Ah,0Dh,"     Program Terminated!  R",153,142,"K NOG!",0Ah,0Dh,'$'

DataSeg ends		      	; data segment ends	
;........................................................................
;
;...................................; code segment begins................
CodeSeg segment  
;........................................................................
;
;...................................; tell assembler which segment is in what register
assume cs:CodeSeg, ds:DataSeg, ss:StackSeg 
;........................................................................ 
;              
start:     		            	; begin algorithm
;........................................................................
;						; move data segment into DS
;........................................................................
	mov AX,DataSeg	      	; base address
	mov DS,AX		     		; of data segment
;........................................................................
;						; input drive
;........................................................................
	msg MessageIn			; introductory message
	mov AH, 01h				; read character function
	int 21h				; call interrupt
	.IF(AL > 96)			; A=65 a=97
	SUB AL, 96 				; turn letter into number
	mov drive, AL			; drive number
	.ELSE					; test
	SUB AL, 64				; turn letter into number
	mov drive, AL			; drive number
	.ENDIF				; end test
;........................................................................
;						; read sector		
;........................................................................
	mov SI, 0h				; read function 6001h for write function
	mov CX, 0FFFFh			; cx must be -1
;........................................................................
	mov AL, 0				; boot sector
	mov BYTE PTR diStartSector, AL; 
	mov BX, seg dio 			; pointer to disk input output
	mov DS, BX				; structure is in
	mov BX, offset dio		; DS:BX
;........................................................................
	mov DL, drive			; drive a:
	mov AX, 7305h 			; absolute disk read function
	int 21h				; call interrupt
;........................................................................
;						; create data output file
;........................................................................
	mov AX,DataSeg	      	; base address
	mov DS,AX		     		; of data segment
	lea DX,PATH		      	; DS:DX is address of filename
	mov AH,3Ch		  		; function 3Ch is for creating a file
	xor CX,CX				; CX = 0 for an ordinary file
	int 21h				; create file interupt
	mov HANDLE,AX			; save value of file handle
;........................................................................
;						; write sector to file
;........................................................................
	LEA DX, buffy			; DS:DX address of buffer
	mov AH, 40h				; write to file function
	mov BX, HANDLE			; handle
	mov CX, 512				; number of bytes to write
	int 21h				; write to file interupt
;........................................................................
;						; close file
;........................................................................
	mov BX, HANDLE			; file handle
	mov AH, 3Eh				; close file function
	int 21h				; close file interrupt
;........................................................................
;						; display media ID and messages
;........................................................................
	msg Message0			; output message 0
	mov AL, drive			; display drive letter
	ADD AL, 64				; display drive letter
	int 29h				; display drive letter
	msg CRLF				; new line
	msg Message1			; output message 1
	mov AL, buffy[21]			; display media ID
	mov NUMVALUE, AL			; display media ID
	CALL DisplayNum			; display media ID
	msg Message2			; output message 2
;........................................................................
	mov AX,4C00h			; termination function
	int 21h				; termination interupt
;........................................................................
;						; Display Number Procedure
;........................................................................
	DisplayNum proc
	push AX
	push BX
	push CX
	push DX
      mov AH, 0
      mov AL, NUMVALUE			; Number To Be Displayed
	mov BX, 10
	mov CX, 0
DNexDiv:
	mov DX, 0
	div BX
	push DX
	inc CX
	cmp AX,0
	jne DNexDiv
	mov AX, 200h
DOutSym: pop DX
	add DL, '0'
	int 21h
	loop DOutSym
	pop DX
	pop CX
	pop BX
	pop AX
	ret
	DisplayNum endp
;........................................................................
CodeSeg    ends       	      	; end algorithm
;........................................................................
end  start 			      	; end program